# coding: utf-8

"""
    mod-dlm API

    mod-dlm is an open source domain specific language to describe prefab construction elements. This project provides tools for defining entity models and automatically generating CRUD APIs, enabling suppliers to create and manage catalogs of their products easily.

    The version of the OpenAPI document: 1.0.8
    Contact: info@mod.construction
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json




from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from mod_dlm_server.models.prefab_element_structural_properties_load_bearing_capacity import PrefabElementStructuralPropertiesLoadBearingCapacity
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class PrefabElementStructuralProperties(BaseModel):
    """
    PrefabElementStructuralProperties
    """ # noqa: E501
    load_bearing_capacity: Optional[PrefabElementStructuralPropertiesLoadBearingCapacity] = Field(default=None, alias="loadBearingCapacity")
    seismic_resistance: Optional[StrictStr] = Field(default=None, alias="seismicResistance")
    wind_load_resistance: Optional[StrictStr] = Field(default=None, alias="windLoadResistance")
    __properties: ClassVar[List[str]] = ["loadBearingCapacity", "seismicResistance", "windLoadResistance"]

    @field_validator('seismic_resistance')
    def seismic_resistance_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Zone 1', 'Zone 2', 'Zone 3', 'Zone 4',):
            raise ValueError("must be one of enum values ('Zone 1', 'Zone 2', 'Zone 3', 'Zone 4')")
        return value

    @field_validator('wind_load_resistance')
    def wind_load_resistance_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('Class A', 'Class B', 'Class C', 'Class D',):
            raise ValueError("must be one of enum values ('Class A', 'Class B', 'Class C', 'Class D')")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of PrefabElementStructuralProperties from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of load_bearing_capacity
        if self.load_bearing_capacity:
            _dict['loadBearingCapacity'] = self.load_bearing_capacity.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of PrefabElementStructuralProperties from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "loadBearingCapacity": PrefabElementStructuralPropertiesLoadBearingCapacity.from_dict(obj.get("loadBearingCapacity")) if obj.get("loadBearingCapacity") is not None else None,
            "seismicResistance": obj.get("seismicResistance"),
            "windLoadResistance": obj.get("windLoadResistance")
        })
        return _obj


